#ifndef _P3P_H_
#define _P3P_H_

//
//
//	Definitions
//
//
#define BUF_LEN 2047
#define LINE_LEN 511
#define NS_LEN 16
#define MAX_OR 128

#define P3P_IMAGE_X 28
#define P3P_IMAGE_Y 16

#define P3P_CACHE_MARGIN 300

//
//
//	String Table
//
//
#define P3Pss_EMPTY          (const char*)""
#define P3Ps_ALLOW           (const xmlChar*)"PREFIX"
#define P3Ps_ALLOW_GROUP     (const xmlChar*)"PREFIX-GROUP"
#define P3Ps_APPEL           (const xmlChar*)"APPEL"
#define P3Ps_APPLY_URI       (const xmlChar*)"apply"
#define P3Ps_A_RULE          (const char*)"An APPEL Rule"
#define P3Ps_BEHAVIOR        (const xmlChar*)"behavior"
#define P3Ps_B_ACCEPT        (const xmlChar*)"accept"
#define P3Ps_B_INFORM        (const xmlChar*)"inform"
#define P3Ps_B_REJECT        (const xmlChar*)"reject"
#define P3Ps_B_UNKNOWN       (const xmlChar*)"unknown"
#define P3Ps_B_WARN          (const xmlChar*)"warn"
#define P3Ps_CACHE           (const char*)"cache"
#define P3Ps_CK_CHECK        (const char*)"Check Links"
#define P3Ps_CK_UNCHECK      (const char*)"UnCheck"
#define P3Ps_DENY            (const xmlChar*)"EXCLUDE"
#define P3Ps_DENY_GROUP      (const xmlChar*)"EXCLUDE-GROUP"
#define P3Ps_DESCRIPTION     (const xmlChar*)"description"
#define P3Ps_DISCLOSURE      (const xmlChar*)"DISCLOSURE"
#define P3Ps_DISCURI         (const xmlChar*)"discuri"
#define P3Ps_EMPTY           (const xmlChar*)""
#define P3Ps_EMP_END         (const char*)"]"
#define P3Ps_EMP_START       (const char*)"["
#define P3Ps_FALSE           (const xmlChar*)"false"
#define P3Ps_GENERAL         (const char*)"General"
#define P3Ps_HEAD_CACHE      (const char*)"Policy-CC:"
#define P3Ps_HEAD_EXCLUDE    (const char*)"Exclude:"
#define P3Ps_HEAD_POLICY     (const char*)"Policy:"
#define P3Ps_HEAD_PREFIX     (const char*)"Prefix:"
#define P3Ps_HTTP            (const char*)"http://"
#define P3Ps_IGUNKN          (const char*)"IgnoreUnknown"
#define P3Ps_INIFILE         (const char*)"P3P.ini"
#define P3Ps_LIFETIME        (const xmlChar*)"time"
#define P3Ps_MATCH           (const char*)"match"
#define P3Ps_MATCHED         (const xmlChar*)"matched"
#define P3Ps_MATCHED_LEAF    (const xmlChar*)"matchedLeaf"
#define P3Ps_NAME            (const char*)"name"
#define P3Ps_NO              (const char*)"No"
#define P3Ps_NS_APPEL        (const xmlChar*)"http://www.w3.org/TR/APPEL"
#define P3Ps_NS_EQ           (const char*)";ns="
#define P3Ps_OPT             (const char*)"Opt:"
#define P3Ps_P3P             (const char*)"\"http://www.w3.org/2000/P3Pv1\""
#define P3Ps_P3P_NS          (const char*)"\"http://www.w3.org/2000/P3Pv1\";ns="
#define P3Ps_POLICY          (const xmlChar*)"POLICY"
#define P3Ps_POLICYCACHE     (const char*)"cache.xml"
#define P3Ps_POLICY_CACHE    (const xmlChar*)"POLICY-CACHE"
#define P3Ps_PREFFILE        (const char*)"pref.xml"
#define P3Ps_QUANT           (const xmlChar*)"quantifier"
#define P3Ps_QUANT_ALL       (const xmlChar*)"all"
#define P3Ps_QUANT_ANY       (const xmlChar*)"any"
#define P3Ps_QUANT_EXACT     (const xmlChar*)"exact"
#define P3Ps_QUANT_ONLY      (const xmlChar*)"only"
#define P3Ps_RULE            (const xmlChar*)"RULE"
#define P3Ps_SELECTED        (const char*)"*"
#define P3Ps_SPACE           (const char*)" "
#define P3Ps_TRUE            (const xmlChar*)"true"
#define P3Ps_URI             (const xmlChar*)"uri"
#define P3Ps_VALUE           (const char*)"value"
#define P3Ps_YES             (const char*)"Yes"

//
//
//	Global Functions
//
//
extern char* CopyChar(const char* str);
xmlChar* CopyChar(const xmlChar* str);

#endif
